/*
 * Copyright (C) The Apache Software Foundation. All rights reserved.
 *
 * This software is published under the terms of the Apache Software
 * License version 1.1, a copy of which has been included with this
 * distribution in the LICENSE.txt file.  */
/*
 * Created on 2004/11/09
 * For Witmate Project
 */
package log4j2me.util;

import java.util.Vector;
import log4j2me.util.StringTokenizer;
import log4j2me.util.Properties;
import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.helpers.LogLog;

/** 
 *
 * PropertyConfigurator for J2ME to get properties by getAppProperty
 * 
 * @author Witmate
 */
public class AppPropertyConfigurator {
	static final String CATEGORY_LIST = "log4j.categories";//Witmate: List all category names	
	
	/**
	 * 
	 * @param midlet
	 * @return FormAppenders.
	 */
	static public Vector config(javax.microedition.midlet.MIDlet midlet){		
		
		//Get CATEGORY_LIST
		Vector categories=new Vector();		
		StringTokenizer st=new StringTokenizer(midlet.getAppProperty(CATEGORY_LIST), ",");
		LogLog.debug(CATEGORY_LIST+":"+midlet.getAppProperty(CATEGORY_LIST));
		while(st.hasMoreTokens()){
			categories.addElement(st.nextToken().trim());
		}
		LogLog.debug("categories:"+categories.toString());
		////Get porperies
		Properties props=new Properties();
		props.openAppPropertiesGetting(midlet);
		String temp, key;		
		//Get log4j.category.*
		for(int i=0;categories.size()>i;i++){
			key=PropertyConfigurator.CATEGORY_PREFIX+categories.elementAt(i);
			temp=midlet.getAppProperty(key);
			if(null!=temp){
				props.put(key, temp);
			}
		}
		
		LogLog.debug(props.toString());
		return PropertyConfigurator.configure(props);		
	}	
}
